/** 
 * @author Eugene Turkov
 * @author <a href="mailto:eugene.turkov@nasa.gov">eugene.turkov@nasa.gov</a>
 * @version: 1.0
 * @since SDK1.5
 * 
 * NASA Ames Research Center Computational Sciences Division Intelligent Data
 * Understanding Group (IDU) Moffett Field, CA 94035
 */

package turkov.lang;

import java.util.HashMap;

/**
 * Adapter class.
 */
public class TUObjectExtension implements Comparable
{

	/** Creates a new instance of TUObjectExtension */
	public TUObjectExtension(Object rootObject)
	{
		this.rootObject = (Comparable) rootObject;
		properties = new HashMap();
	}

	public Object getRootObject()
	{
		return rootObject;
	}

	public void setProperty(Object property, Object value)
	{
		properties.put(property, value);
	}

	public Object getPropertyValue(Object property)
	{
		return properties.get(property);
	}

	public boolean equals(Object object)
	{
		return object.equals(rootObject);
	}

	public String toString()
	{
		return rootObject.toString();
	}

	public int hashCode()
	{
		return rootObject.hashCode();
	}

	public int compareTo(Object object)
	{
		return rootObject.compareTo((Comparable) object);
	}

	private HashMap properties;
	private Comparable rootObject;
}
